/* Javascript HTML Button object */
/* Copyright 2007 CardBoardFish  */
/* http://www.cardboardfish.com/ */

var bheight = "21px";
var bleft = "10px";
var bright = "9px";

var buttononlyonce = 0;

function buttonmode(currentbutton, mode) {
    if (currentbutton.lastmode) {
        if (currentbutton.lastmode == mode) {
            return;
        }
    }
    if (mode === 0) {
       currentbutton.childNodes[0].style.backgroundImage = "url(images/button_left.png)";
       currentbutton.childNodes[1].style.backgroundImage = "url(images/button_middle.png)";
       currentbutton.childNodes[2].style.backgroundImage = "url(images/button_right.png)";
    } else if (mode === 1) {
       currentbutton.childNodes[0].style.backgroundImage = "url(images/button_hover_left.png)";
       currentbutton.childNodes[1].style.backgroundImage = "url(images/button_hover_middle.png)";
       currentbutton.childNodes[2].style.backgroundImage = "url(images/button_hover_right.png)";
    } else if (mode === 2) {
       currentbutton.childNodes[0].style.backgroundImage = "url(images/button_clicked_left.png)";
       currentbutton.childNodes[1].style.backgroundImage = "url(images/button_clicked_middle.png)";
       currentbutton.childNodes[2].style.backgroundImage = "url(images/button_clicked_right.png)";
    }
    currentbutton.lastmode = mode;
}


function cbf_down(event) {
    buttonmode(this, 2);
}

function cbf_over(event) {
    buttonmode(this, 1);
    return true;
}

function cbf_out(event) {
    buttonmode(this, 0);
    return true;
}

function cbf_up(event) {
    buttonmode(this, 1);
}

function cbf_click(event) {
    var result = this._onclick(event);
    if (result) {
        buttonmode(this, 0);
    }
    return result;
}

function CBFButton(id, label, onclick) {

    var bdiv = document.createElement("div");
    bdiv.id = "CBF_BUTTON_" + buttononlyonce;
    bdiv.style.display = "inline-block";
    bdiv.className = "cbfbutton";
    bdiv.onmouseover = cbf_over;
    bdiv.onmouseout = cbf_out;
    bdiv._onclick = onclick;
    bdiv.onclick = cbf_click;
    bdiv.onmousedown = cbf_down;
    bdiv.onmouseup = cbf_over;
    bdiv.style.cursor = "pointer";
    bdiv.style.overflow = "hidden";

    var leftside = document.createElement("div");
    leftside.style.display = "inline-block";
    leftside.style.background = "no-repeat top left";
    leftside.style.width = bleft;
    leftside.style.height = bheight;
    bdiv.appendChild(leftside);

    var bmiddle = document.createElement("div");
    bmiddle.id = "CBF_BUTTON_LABEL_" + buttononlyonce;
    bmiddle.innerText = label;
    bmiddle.style.color = "#000000";
    bmiddle.style.display = "inline-block";
    bmiddle.style.backgroundRepeat = "repeat-x";
    bmiddle.style.lineHeight = bheight;
    bmiddle.style.overflow = "hidden";
    bmiddle.style.height = bheight;
    bmiddle.style.appleDashboardRegion = "dashboard-region(control rectangle)";
    bdiv.appendChild(bmiddle);

    var rightside = document.createElement("div");
    rightside.style.display = "inline-block";
    rightside.style.background = "no-repeat top left";
    rightside.style.width = bright;
    rightside.style.height = bheight;
    bdiv.appendChild(rightside);

    this._onclick = onclick;
    this._buttondiv = bdiv;

    var loc = document.getElementById(id);
    if (loc) {
        loc.appendChild(bdiv);
    }
    buttonmode(bdiv, 0);

    buttononlyonce++;
    
}

CBFButton.prototype.setText = function(text) {
    var myidparts = this._buttondiv.id.split("_");
    var labelid = myidparts[2];

    var label = document.getElementById("CBF_BUTTON_LABEL_" + labelid);
    if (label) {
        label.innerText = text;
    }
}

CBFButton.prototype.setAction = function(func) {
    this._onclick = func;
}
